Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes
Lucene::ThreadPool Class Reference

Utility class to handle a pool of threads. More...

`#include <ThreadPool.h>`

Inheritance diagram for Lucene::ThreadPool:

## Public Member Functions

| ThreadPool ()
virtual | ~ThreadPool ()
virtual String | getClassName ()
boost::shared_ptr< ThreadPool > | shared_from_this ()
template<typename FUNC >
FuturePtr | scheduleTask (FUNC func)
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
static ThreadPoolPtr | getInstance ()
| Get singleton thread pool instance. More...

## Protected Member Functions

template<typename FUNC >
void | execute (FUNC func, FuturePtr future)
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

boost::asio::io_service | io_service
workPtr | work
boost::thread_group | threadGroup

## Static Protected Attributes

static const int32_t | THREADPOOL_SIZE

## Detailed Description

Utility class to handle a pool of threads.

## Constructor & Destructor Documentation

Lucene::ThreadPool::ThreadPool | ( | ) |  |

virtual Lucene::ThreadPool::~ThreadPool | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::ThreadPool::_getClassName | ( | ) |  |

inline static

template<typename FUNC >

void Lucene::ThreadPool::execute | ( | FUNC | func,
|  | FuturePtr | future
| ) |  |

inline protected

virtual String Lucene::ThreadPool::getClassName | ( | ) |  |

inline virtual

static ThreadPoolPtr Lucene::ThreadPool::getInstance | ( | ) |  |

static

Get singleton thread pool instance.

template<typename FUNC >

FuturePtr Lucene::ThreadPool::scheduleTask | ( | FUNC | func) |  |

inline

References io_service.

boost::shared_ptr< ThreadPool > Lucene::ThreadPool::shared_from_this | ( | ) |  |

inline

## Field Documentation

boost::asio::io_service Lucene::ThreadPool::io_service

protected

Referenced by scheduleTask().

boost::thread_group Lucene::ThreadPool::threadGroup

protected

const int32_t Lucene::ThreadPool::THREADPOOL_SIZE

static protected

workPtr Lucene::ThreadPool::work

protected

The documentation for this class was generated from the following file:

- ThreadPool.h

clucene.sourceforge.net